import com.j_phone.system.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

// Device̕\
final class DeviceInfoCanvas extends Canvas
    implements Runnable,CommandListener {

final int CENTER =  60;
final int R      =  60;
final int WIDTH  = 120;
final int HIGHET = 120;
final int NUM    =  60;

   static int Tick = 15;

   int IntensityData[] = new int[8];  // dExۑpz

   private DeviceControl dc;          //foCXRg[
   Display display;

   private int    Battery   = 0;
   private int    Intensity = 0;
   private int    Latitude  = 0;
   private int    Longitude = 0;
   private String PlaceName;

   private Image     offImage;          // _uobt@OpImage
   private Graphics  offGraphics;       // _uobt@OpGraphics

   //RXgN^
   DeviceInfoCanvas(Display display) {
      this.display = display;
      dc = DeviceControl.getDefaultDeviceControl();
      setCommandListener(this);
      offImage    = Image.createImage(getWidth(),getHeight()); // _uobt@OpImage
      offGraphics = offImage.getGraphics();                    // _uobt@OpGraphics
   }

   //L[vXCxg
   protected synchronized void keyPressed(int keyCode) {
   }

   //L[[X
   protected synchronized void keyReleased(int keyCode) {
   }

   public void CountUp() {
      Tick--;
      if (Tick < 0) Tick = 59;
   }

    //s
    public void run() {
        while (true) {
            //`
            //--------------------
            CountUp();
            repaint();
            try {
                Thread.sleep(250);
            }catch (Exception e) {
            }
        }
    }

   //`
   public void paint(Graphics g) {
      int r = 0;
      int x, y, w, h;
      int degrees   = 0; // x
      int arcminute = 0; // 
      int arcsecond = 0; // b
      // level meter̕ƍ̒`
      int lmw    = 100;
      int lmh    =   8;

      // _uobt@ĂȂꍇ́CȂŖ߂B
      if (null == offGraphics) return;

//    offGraphics.setColor(255,255,255);
//    offGraphics.setColor(239,239,239);
//    offGraphics.setColor(224,224,224);
      offGraphics.setColor(255,255,192);
      offGraphics.fillRect(0,0,getWidth(),getHeight());
      offGraphics.setColor(  0,  0,  0);


      // e̎擾
      Battery   = dc.getDeviceState(DeviceControl.BATTERY);         // obe[c(%)擾B
      Intensity = dc.getDeviceState(DeviceControl.FIELD_INTENSITY); // dEx(%)擾B
      try {
         Latitude  = dc.getLatitude();                              // ݂̈ܓx擾B
         Longitude = dc.getLongitude();                             // ݂̌ox擾B
         PlaceName = dc.getPlaceName();                             // ݈ʒu̒n擾B 
      } catch(SecurityException e) {
         Latitude  = 0;
         Longitude = 0;
         PlaceName = new String("ZLeBᔽ");
      } catch(IllegalStateException e) {
         Latitude  = 0;
         Longitude = 0;
         PlaceName = new String("sK؂ȃ\bȟďo");
      }
      x = 5;
      y = 0;
      offGraphics.drawString("foCX", getWidth() / 2, y, g.HCENTER|g.TOP);
      y += 16;

      offGraphics.drawLine(0, y, getWidth(), y);
      y += 2;
      degrees   = Latitude  / 3600;
      arcminute = Latitude  % 3600;
      arcsecond = arcminute %   60;
      arcminute = arcminute /   60;
      offGraphics.drawString("k  " + degrees + "x" + arcminute + "" + arcsecond + "b", x, y, g.LEFT|g.TOP);
      y += 16;
      degrees   = Longitude / 3600;
      arcminute = Longitude % 3600;
      arcsecond = arcminute %   60;
      arcminute = arcminute /   60;
      offGraphics.drawString("o " + degrees + "x" + arcminute + "" + arcsecond + "b", x, y, g.LEFT|g.TOP);
      y += 16;
      offGraphics.drawString("݈ʒu̒n "         , x, y, g.LEFT|g.TOP);
      y += 16;
      offGraphics.drawString(PlaceName                           , x, y, g.LEFT|g.TOP);

      y += 15;
      offGraphics.drawLine(0, y, getWidth(), y);
      y += 2;
      offGraphics.drawString("dEx       " + Intensity + "%", x, y, g.LEFT|g.TOP);
      y += 14;
      offGraphics.setColor(255,255,255);
      offGraphics.fillRect(x, y, lmw      , lmh);
      offGraphics.setColor(0,0,255);
      offGraphics.fillRect(x, y, Intensity, lmh);
      offGraphics.setColor(32,32,32);
      for (int i = 1; i < 10; i++) {
         offGraphics.drawRect(x, y, (lmw / 10) * i, lmh   );
       }
      offGraphics.setColor(0,0,0);
      offGraphics.drawRect(x, y, lmw, lmh);
      y += 10;
      offGraphics.drawString(  "0", x,           y, g.HCENTER|g.TOP);
      offGraphics.drawString( "50", x + lmw / 2, y, g.HCENTER|g.TOP);
      offGraphics.drawString("100", x + lmw,     y, g.HCENTER|g.TOP);
      y += 14;
      offGraphics.drawString("obe[c " + Battery   + "%", x, y, g.LEFT|g.TOP);
      y += 14;
      offGraphics.setColor(255,255,255);
      offGraphics.fillRect(x, y, lmw      , lmh);
      switch (Battery / 10) {
         case  0 : offGraphics.setColor(255,  0,  0); break;
         case  1 : offGraphics.setColor(255,255,  0); break;
         case  2 : offGraphics.setColor(255,255,  0); break;
         default : offGraphics.setColor(0  ,255,  0); break;
      }
      offGraphics.fillRect(x, y, Battery, lmh);
      offGraphics.setColor(32,32,32);
      for (int i = 1; i < 10; i++) {
         offGraphics.drawRect(x, y, (lmw / 10) * i, lmh   );
       }
      offGraphics.setColor(0,0,0);
      offGraphics.drawRect(x, y, lmw, lmh);
      y += 10;
      offGraphics.drawString(  "0", x,           y, g.HCENTER|g.TOP);
      offGraphics.drawString( "50", x + lmw / 2, y, g.HCENTER|g.TOP);
      offGraphics.drawString("100", x + lmw,     y, g.HCENTER|g.TOP);


      // _uobt@O̓e]B
      g.drawImage(offImage, 0, 0, g.LEFT|g.TOP);
   }

   //R}hCxg
   public void commandAction(Command c,Displayable s) {
   }
}
